function switchToRunningShow(channel, button)
{
	if(typeof(button) == "string") button = document.getElementById(button);
	button.setAttribute("src", "Images/EyeTV_progressing.png");
	
	var eyetvwasrunning = eyeTVIsRunning();
	if (!eyetvwasrunning)
	{
		asTell("activate");
		setTimeout("switchToRunningShow(\""+channel+"\",\""+button.getAttribute('id')+"\");", 2000);
		return;
	}

	if (eyetvIsCurrentlyPlaying != "")
	{
		var oldbutton = document.getElementById("playingButton_" + eyetvIsCurrentlyPlaying);
		if (undefined != oldbutton) oldbutton.setAttribute("src", "Images/EyeTV_readyToPlay.png");
	}
	eyetvIsCurrentlyPlaying = channel;
	//button.setAttribute("src", "Images/EyeTV_progressing.png");
	switchToEyeTVChannel(eyetvChannels[channel]);
	button.setAttribute("src", "Images/EyeTV_playing.png");
}

function switchToEyeTVChannel(channel)
{
	if (1 == useFormac)
	{
		var formacChannels = getEyeTVChannels();
		var channelIndex = indexOfObjectInArray(formacChannels, channel);
		if (-1 != channelIndex) FernsehPlugin.appleScript("tell application \"" + appName + "\" to set channel Index of first formacDVBTuner of first document to " + channelIndex);
		return;
	}
	asTell("set the current channel to (the channel number of (the first channel whose name contains \"" + channel + "\"))");
}

function deleteRecordTimerForShow(channel, showname, showlength, button, timestamp)
{
	if(typeof(button) == "string") button = document.getElementById(button);
	var temp_img = new Image();
	temp_img.src = "Images/EyeTV_progressing2.png";
	button.setAttribute("src", temp_img.src);
	
	var eyetvwasrunning = eyeTVIsRunning();
	if (!eyetvwasrunning)
	{
		asTell("activate");
		setTimeout("deleteRecordTimerForShow(\""+channel+"\",\""+showname+"\",\""+showlength+"\",\""+button.getAttribute('id')+"\",\""+timestamp+"\");", 2000);
		return;
	}

	if (useFormac == 1)
	{
		// later on, do something here
		var date = new Date();
		date.setTime(timestamp);
		var ourDateString = date.toLocaleString();
		
		FernsehPlugin.appleScript("set aStartDateStr to \"" + ourDateString + "\"\nset mDateStart to date aStartDateStr\ntell application\"" + appName + "\"\nactivate\nset aDoc to first document\nset aChan to first formacDVBTuner of aDoc\nset RemoveScheduledEntry of aChan to mDateStart\nend tell");
	} else {
		var recordID = FernsehPlugin.recordingUniqueIDForChannel(eyetvChannels[channel], ""+timestamp);
		if (undefined == recordID)
		{
			alert("Ouch, couldn't find Unique ID for show. Sorry.");
			return;
		}
			
		asTell("delete (every program whose unique ID is " + recordID + ")");
	}
	button.setAttribute("src", "Images/EyeTV_readyToRecord.png");
	button.setAttribute('title', 'Sendung aufnehmen');
	button.setAttribute("onclick", "setRecordTimerForShow(\"" + channel + "\", \"" + showname.replace(/"/g, "\\\"") + "\", \"" + showlength + "\", this, " + timestamp + ");");
}

function setRecordTimerForShow(channel, showname, showlength, button, timestamp)
{	
	var temp_img = new Image();
	temp_img.src = "Images/EyeTV_progressing2.png";
	button.setAttribute("src", temp_img.src);
	
	var date = new Date();
	date.setTime(timestamp);

	var ourDateString = date.toLocaleString();
	
	if (useFormac == 1)
	{
		var endTime = ((Math.abs(showlength) * 60000) + timestamp);
		var endDate = new Date();
		endDate.setTime(endTime);
		var recChannel = eyetvChannels[channel];
		var formacChannels = getEyeTVChannels();
		var channelIndex = indexOfObjectInArray(formacChannels, recChannel);
		if (-1 != channelIndex) FernsehPlugin.appleScript("set aChannelIndex to \"" + (channelIndex+1) + "\"\nset aMovieName to \"" + showname.replace(/"/g, "\\\"") + "\"\nset aStartDateStr to \"" + ourDateString + "\"\nset aStopDateStr to \"" + endDate.toLocaleString() + "\"\nset mDateStart to date aStartDateStr\nset mDateStop to date aStopDateStr\ntell application \"" + appName + "\"\nactivate\nset aDoc to first document\nset aChan to first formacDVBTuner of aDoc\nset channelList to channel List of aChan\nset aChannelName to item aChannelIndex of channelList\nset theRecChunk to {aChannelName, aMovieName, mDateStart, mDateStop}\nset video Dimension of aChan to 1.0\nset InsertScheduleEntry of aChan to theRecChunk\nend tell\n");
	} else {
		// EyeTV
		prog = new eyeTVSchedule();
		prog.starttime = ourDateString;
		prog.duration = (Math.abs(showlength) * 60);
		prog.stationname = eyetvChannels[channel];
		prog.title = showname.replace(/"/g, "\\\"");
		prog.createSchedule();
	}
	if ("" == button) return; // DEBUG
	button.setAttribute("src", "Images/EyeTV_recording.png");
	button.setAttribute('title', 'Sendung wird aufgenommen');
	button.setAttribute("onclick", "deleteRecordTimerForShow(\"" + channel + "\", \"" + showname.replace(/"/g, "\\\"") + "\", \"" + showlength + "\", this, " + timestamp + ");");
}

function indexOfStation(tvtodayname)
{
	var availChannels = getEyeTVChannels();
	var eyetvChannelName = eyetvChannels[tvtodayname];
	return indexOfObjectInArray(availChannels, eyetvChannelName);
}

function eyeTVChannelsAssigned()
{
	var numAssignedChannels = 0;
	for (var channel in eyetvChannels)
	{
		numAssignedChannels++;
	}
	return (numAssignedChannels > 0);
}

function getEyeTVChannels()
{
	//alert(FernsehPlugin.formacChannels());
	if (1 == useFormac)
	{
		// Formac is a little... well
		// it doesn't return channels until it has fully launched
		var counter = 0;
		var channels = FernsehPlugin.formacChannels();
		while (undefined == channels)
		{
			channels = FernsehPlugin.formacChannels();
			if (counter++ == 1000) return undefined;
		}
		return channels;
		//return FernsehPlugin.formacChannels();
	}
	return FernsehPlugin.eyeTVChannels();
}

function eyeTVIsRunning()
{
	if (1 == useFormac) return (eyeTVrunning = widget.system("ps -ulwwx | grep \"FormacDVB.app/Contents/MacOS/FormacDVB\" | grep -v grep | wc -l", null).outputString.indexOf("1") == 7)
	return (eyeTVrunning = widget.system("ps -ulwwx | grep \"" + FernsehPlugin.appNameForEyeTV() + ".app/Contents/MacOS/EyeTV\" | grep -v grep | wc -l", null).outputString.indexOf("1") == 7);
}

function currentStation()
{
	if (!eyeTVIsRunning()) return "";
	
	var currStation;
	if (1 == useFormac) currStation = FernsehPlugin.currentFormacStation();
	else currStation = FernsehPlugin.currentStation();
	
	for (var channel in eyetvChannels)
	{
		if (eyetvChannels[channel] == currStation) return channel;
	}
	return "";
}

// Applescript wrappers, partially copy & paste from Elgato sample code
var kMissingValueString = "missing value"; // string constant returned, if an AppleScript didn't succeed.
var appName = "EyeTV";

// Send a command to Application
function asTell(command) {
	if (1 == useFormac) appName = "FormacDVB";
	if (FernsehPlugin) FernsehPlugin.appleScript('tell application "' + appName + '"\n try\n' + command + '\n on error\n return "' + kMissingValueString + '"\n end try\n end tell\n');
}

function eyeTVSchedule() {
	
	this.starttime = "";
	this.duration = 30;
	this.title = "Untitled";
	this.stationname = "";
	
	this.createSchedule = function() {
		cmd = 'make new program with properties {start time:date "' +
				this.starttime + '", duration:' + 
				this.duration + ', title:"' + 
				this.title + 
				'", channel number:(the channel number of (the first channel whose name contains "' + this.stationname + '")) as integer' +
				'}';
		asTell(cmd);
	}	
}
